﻿------------------------------------------------------------------------------------
-- NiceAutoChannel by Mr.Dio (MrDio#2565) Version 1.2 (20:12 29.02.2016)
------------------------------------------------------------------------------------
--
-- Changelog:
--
-- 1.0
----------------------------
-- + Add Auto Chat Channel to Chat Tabs
--
-- 1.1
----------------------------
-- ! Fix instance chat problem
-- + 6.0 support
--
-- 1.2
----------------------------
-- ! Fix some errors
--
------------------------------------------------------------------------------------
-- NiceAutoChannel
------------------------------------------------------------------------------------

local Config = NACConfig

local NACFrame=CreateFrame("Frame")
NACFrame:RegisterEvent("ADDON_LOADED")
NACFrame:SetScript("OnEvent", function(Self, Event, Addon)
	if (Event == "ADDON_LOADED" and Addon == "NiceAutoChannel") then

		hooksecurefunc("ChatEdit_ActivateChat", function(ChatEditBox)
			local Name = _G[SELECTED_DOCK_FRAME:GetName().."Tab"]:GetText()
			if Config[Name] then
				local ChatType = string.upper(Config[Name].ChatType)
				if ChatType == "WHISPER" then
					local lastTold, lastToldType = ChatEdit_GetLastToldTarget()
					if lastTold then
						ChatEditBox:SetAttribute("chatType", lastToldType)
						ChatEditBox:SetAttribute("tellTarget", lastTold)
					else
						local lastTell, lastTellType = ChatEdit_GetLastTellTarget()
						if lastTell then
							ChatEditBox:SetAttribute("chatType", lastTellType)
							ChatEditBox:SetAttribute("tellTarget", lastTell)
						end
					end
				elseif ChatType == "CHANNEL" then
					if Config[Name].Channel then
						ChatEditBox:SetAttribute("chatType", ChatType)
						ChatEditBox:SetAttribute("channelTarget", Config[Name].Channel)
					end
				elseif ChatType == "INSTANCE_CHAT" then
					if IsInGroup(LE_PARTY_CATEGORY_INSTANCE) then
						ChatEditBox:SetAttribute("chatType", "INSTANCE_CHAT")
					elseif IsInRaid(LE_PARTY_CATEGORY_HOME) then
						ChatEditBox:SetAttribute("chatType", "RAID")
					elseif IsInGroup() then
						ChatEditBox:SetAttribute("chatType", "PARTY")
					end
				else
					ChatEditBox:SetAttribute("chatType", ChatType)
				end
			end
		end)



		LAST_SELECTED_TAB_FRAME = nil
		SELECTED_TAB_FRAME = nil

		for i = 1, MAX_WOW_CHAT_CHANNELS do
			_G["ChatFrame"..i.."Tab"]:HookScript("OnClick",function(self, button)

				LAST_SELECTED_TAB_FRAME = SELECTED_TAB_FRAME
				SELECTED_TAB_FRAME = self

				local Name = self:GetText()
			
				if Config[Name] then
					if button == "LeftButton" then
						if Config[Name].OnClickOpen then
							ChatFrame_OpenChat("",SELECTED_DOCK_FRAME)
						else
							if self == LAST_SELECTED_TAB_FRAME then
								ChatFrame_OpenChat("",SELECTED_DOCK_FRAME)
							end
						end
					end
				else
					if button == "LeftButton" then
						if DefaultOnClickOpen then
							ChatFrame_OpenChat("",SELECTED_DOCK_FRAME)
						else
							if self == LAST_SELECTED_TAB_FRAME then
								ChatFrame_OpenChat("",SELECTED_DOCK_FRAME)
							end
						end
					end
				end
			end)
		end
		DEFAULT_CHAT_FRAME:AddMessage(GetAddOnMetadata(Addon, "Title").." v."..GetAddOnMetadata(Addon, "Version").." Loaded!")
	end
end)